/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 31 janvier 2006
   derniere modification le 26/07/2007 */

#ifndef __SCECSUPPORT_H__
#define __SCECSUPPORT_H__


/* nombre de capacites */
#define SCE_NCAPS 17

enum sce_ccapability
{
    SCE_TEX_MULTI,              /* multitexturing */
    SCE_TEX_NON_POWER_OF_TWO,   /* dimensions des textures non puissance de 2 */
    SCE_TEX_HW_GEN_MIPMAP,      /* generation en hardware du mipmapping */
    SCE_TEX_DXT1,               /* compression de texture au format DXT1 */
    SCE_TEX_DXT3,               /* compression de texture au format DXT3 */
    SCE_TEX_DXT5,               /* compression de texture au format DXT5 */
    SCE_TEX_S3TC,               /* compression s3tc (... ?) */
    SCE_TEX_3DC,                /* compression de texture au format 3Dc */
    SCE_VBO,                    /* vertex buffer objects */
    SCE_FBO,                    /* frame buffer objects */
    SCE_PBO,                    /* pixel buffer objects */
    SCE_VERTEX_GLSL_SHADER,     /* vertex shader GLSL */
    SCE_FRAGMENT_GLSL_SHADER,   /* fragment shader GLSL */
    SCE_VERTEX_ASM_PROGRAM,     /* vertex shader assembleur */
    SCE_FRAGMENT_ASM_PROGRAM,   /* fragment shader assembleur */
    SCE_CG_SHADERS,             /* shaders Cg */
    SCE_OCCLUSION_QUERY         /* requete d'occlusion */
};

typedef enum sce_ccapability SCE_CCap;


/* initialisation */
int SCE_CSupportInit(void);


/* renvoie un booleen.
   vrai: l'extension est supportee
   faux: l'extension ne l'est pas */
int SCE_CSupport(const char*);


/* idem que CSupport, mais verifie cette fois chez GLEW */
int SCE_CSupportGlew(const char*);


/* renvoie un booleen si la "capacitee" est supportee */
int SCE_CHasCap(SCE_CCap);


#endif /* guard */
